/*
 * Copyright (C) 2017  Kevin Whitaker <eyecreate@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef WEBINTERFACE_H
#define WEBINTERFACE_H

#include <Wt/WApplication>
#include "GroovePlayer.h"
#include "db/AudioTrack.h"
#include "db/User.h"
#include <Wt/WJavaScript>

class WebInterface : public Wt::WApplication
{
public:
    WebInterface(const Wt::WEnvironment& env);
    ~WebInterface();
    void loginCompleted();
    void playPauseActionFromServer(User userPausing, bool pause);
    void songChangedFromServer(AudioTrack nextTrack);
    void voteTracksUpdatedFromServer(std::list<AudioTrack> voteableTracks);
    void skipVotedFromServer(User userRequestingToSkipCurrentTrack);
    void skipVoteUpdateFromServer(User userVoting, bool forSkip);
    void voteNextSongFromServer(User userVoting, AudioTrack trackVoted);
    void voteNextPollClosedFromServer(AudioTrack winner);
    User currentUser;
private:
    struct internal;
    internal* priv_int = 0;
    std::string getNotificationJs(std::string message);
    Wt::JSlot notificationSlot;
};

#endif // WEBINTERFACE_H
