/*
 * Copyright (C) 2017  Kevin Whitaker <eyecreate@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef USER_H
#define USER_H

#include <Wt/Dbo/Dbo>
#include <Wt/WGlobal>

class User
{
public:
    std::string username;
    std::string passwordHash;
    std::string passwordSalt;
    bool isDisabled;
    bool isAdmin;
    std::string loginCookieToken;
    
    template<class Action>
    void persist(Action& a)
    {
        Wt::Dbo::field(a, username, "username");
        Wt::Dbo::field(a, passwordHash, "hash");
        Wt::Dbo::field(a, passwordSalt, "salt");
        Wt::Dbo::field(a, isDisabled, "disabled");
        Wt::Dbo::field(a, isAdmin, "admin");
        Wt::Dbo::field(a, loginCookieToken, "cookie");
    }
};

#endif
